diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
index 4c87b01d4..6ca2e9507 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
@@ -12,39 +12,41 @@ import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStandard<T> {
     protected final IconCoordinate wireStraight = TextureRegistry.getTexture("minecraft:block/wire_redstone_straight");
     protected final IconCoordinate wireCross = TextureRegistry.getTexture("minecraft:block/wire_redstone_cross");
+
     public BlockModelWireRedstone(Block<T> block) {
         super(block);
         setAllTextures(BLOCK_TEXTURES, "minecraft:block/wire_redstone_cross");
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        int meta = worldSource.getBlockMetadata(x, y, z);
-        IconCoordinate straight = wireStraight;
-        IconCoordinate cross = wireCross;
-        if(renderBlocks.overrideBlockTexture != null)
-        {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int meta = worldSource.getBlockData(tilePos);
+        IconCoordinate straight = this.wireStraight;
+        IconCoordinate cross = this.wireCross;
+        if (renderBlocks.overrideBlockTexture != null) {
             cross = renderBlocks.overrideBlockTexture;
         }
         float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-//            int lmc = block.getLightmapCoord(worldSource, x, y, z);
+        if (LightmapHelper.isLightmapEnabled()) {
+//            int lmc = block.getLightmapCoord(worldSource, tilePos);
 //            if(Blocks.lightEmission[block.id] > 0) {
 //                lmc = LightmapHelper.setBlocklightValue(lmc, 15);
 //            }
-            int lmc = LightmapHelper.getLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, x, y, z), Math.max(worldSource.getSavedLightValue(LightLayer.Block, x, y, z), meta & 0xF));
+            int lmc = LightmapHelper.getLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, tilePos), Math.max(worldSource.getSavedLightValue(LightLayer.Block, tilePos), meta & 0xF));
             tessellator.setLightmapCoord(lmc);
-        }else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
-            if(block.emission > 0) {
+        } else {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
+            if (this.block.emission > 0) {
                 brightness = 1.0f;
             }
-            brightness = Math.max(brightness, (meta & 0xF)/16f);
+            brightness = Math.max(brightness, (meta & 0xF) / 16f);
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
 
@@ -53,54 +55,54 @@ public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStan
         float green = color.getGreen() / 255.0f;
         float blue = color.getBlue() / 255.0f;
 
+        TilePos queryPos = new TilePos();
+
         tessellator.setColorOpaque_F(brightness * red, brightness * green, brightness * blue);
-        boolean west = BlockLogicWireRedstone.shouldConnectTo(worldSource, x - 1, y, z, Side.WEST) || !worldSource.isBlockNormalCube(x - 1, y, z) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x - 1, y - 1, z, Side.NONE, Side.BOTTOM);
-        boolean east = BlockLogicWireRedstone.shouldConnectTo(worldSource, x + 1, y, z, Side.EAST) || !worldSource.isBlockNormalCube(x + 1, y, z) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x + 1, y - 1, z, Side.NONE, Side.BOTTOM);
-        boolean north = BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y, z - 1, Side.NORTH) || !worldSource.isBlockNormalCube(x, y, z - 1) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x, y - 1, z - 1, Side.NONE, Side.BOTTOM);
-        boolean south = BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y, z + 1, Side.SOUTH) || !worldSource.isBlockNormalCube(x, y, z + 1) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x, y - 1, z + 1, Side.NONE, Side.BOTTOM);
+        boolean west = BlockLogicWireRedstone.shouldConnectTo(worldSource, tilePos.west(queryPos), Side.WEST) || !worldSource.isBlockNormalCube(tilePos.west(queryPos)) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, tilePos.add(-1, -1, 0, queryPos), Side.NONE, Side.BOTTOM);
+        boolean east = BlockLogicWireRedstone.shouldConnectTo(worldSource, tilePos.east(queryPos), Side.EAST) || !worldSource.isBlockNormalCube(tilePos.east(queryPos)) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, tilePos.add(1, -1, 0, queryPos), Side.NONE, Side.BOTTOM);
+        boolean north = BlockLogicWireRedstone.shouldConnectTo(worldSource, tilePos.north(queryPos), Side.NORTH) || !worldSource.isBlockNormalCube(tilePos.north(queryPos)) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, tilePos.add(0, -1, -1, queryPos), Side.NONE, Side.BOTTOM);
+        boolean south = BlockLogicWireRedstone.shouldConnectTo(worldSource, tilePos.south(queryPos), Side.SOUTH) || !worldSource.isBlockNormalCube(tilePos.south(queryPos)) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, tilePos.add(0, -1, 1, queryPos), Side.NONE, Side.BOTTOM);
         boolean westUp = false;
         boolean eastUp = false;
         boolean northUp = false;
         boolean southUp = false;
-        if(!worldSource.isBlockOpaqueCube(x, y + 1, z))
-        {
-            if(worldSource.isBlockNormalCube(x - 1, y, z) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x - 1, y + 1, z, Side.NONE, Side.TOP))
-            {
+        if (!worldSource.isBlockOpaqueCube(tilePos.up(queryPos))) {
+            if (worldSource.isBlockNormalCube(tilePos.west(queryPos)) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, tilePos.add(-1, 1, 0, queryPos), Side.NONE, Side.TOP)) {
                 west = true;
                 westUp = true;
             }
-            if(worldSource.isBlockNormalCube(x + 1, y, z) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x + 1, y + 1, z, Side.NONE, Side.TOP))
-            {
+            if (worldSource.isBlockNormalCube(tilePos.east(queryPos)) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, tilePos.add(1, 1, 0, queryPos), Side.NONE, Side.TOP)) {
                 east = true;
                 eastUp = true;
             }
-            if(worldSource.isBlockNormalCube(x, y, z - 1) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x, y + 1, z - 1, Side.NONE, Side.TOP))
-            {
+            if (worldSource.isBlockNormalCube(tilePos.north(queryPos)) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, tilePos.add(0, 1, -1, queryPos), Side.NONE, Side.TOP)) {
                 north = true;
                 northUp = true;
             }
-            if(worldSource.isBlockNormalCube(x, y, z + 1) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, x, y + 1, z + 1, Side.NONE, Side.TOP))
-            {
+            if (worldSource.isBlockNormalCube(tilePos.south(queryPos)) && BlockLogicWireRedstone.shouldConnectToDiagonal(worldSource, tilePos.add(0, 1, 1, queryPos), Side.NONE, Side.TOP)) {
                 south = true;
                 southUp = true;
             }
         }
+
+        final int x = tilePos.x();
+        final int y = tilePos.y();
+        final int z = tilePos.z();
+
         float xMin = x;
         float xMax = x + 1;
         float zMin = z;
         float zMax = z + 1;
 
-        final float onePix = 1f/16;
+        final float onePix = 1f / 16;
         final float renderOffset = 0.015625F;
 
 
         byte type = 0;
-        if((west || east) && !north && !south)
-        {
+        if ((west || east) && !north && !south) {
             type = 1;
         }
-        if((north || south) && !east && !west)
-        {
+        if ((north || south) && !east && !west) {
             type = 2;
         }
 
@@ -110,106 +112,107 @@ public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStan
         if (north) amount++;
         if (south) amount++;
 
-        if (type == 0){
-            if (amount != 0){
+        if (type == 0) {
+            if (amount != 0) {
                 // Render Dot
                 float w = west ? 0 : onePix * 5;
                 float e = east ? 0 : onePix * 5;
                 float s = south ? 0 : onePix * 5;
                 float n = north ? 0 : onePix * 5;
 
-                tessellator.addVertexWithUV(xMax - e, (float)y + renderOffset, zMax - s,  cross.getSubIconU(1 - e), cross.getSubIconV(1 - s));
-                tessellator.addVertexWithUV(xMax - e, (float)y + renderOffset, zMin + n,  cross.getSubIconU(1 - e), cross.getSubIconV(n));
-                tessellator.addVertexWithUV(xMin + w, (float)y + renderOffset, zMin + n,  cross.getSubIconU(w),     cross.getSubIconV(n));
-                tessellator.addVertexWithUV(xMin + w, (float)y + renderOffset, zMax - s,  cross.getSubIconU(w),     cross.getSubIconV(1 - s));
+                tessellator.addVertexWithUV(xMax - e, (float) y + renderOffset, zMax - s, cross.getSubIconU(1 - e), cross.getSubIconV(1 - s));
+                tessellator.addVertexWithUV(xMax - e, (float) y + renderOffset, zMin + n, cross.getSubIconU(1 - e), cross.getSubIconV(n));
+                tessellator.addVertexWithUV(xMin + w, (float) y + renderOffset, zMin + n, cross.getSubIconU(w), cross.getSubIconV(n));
+                tessellator.addVertexWithUV(xMin + w, (float) y + renderOffset, zMax - s, cross.getSubIconU(w), cross.getSubIconV(1 - s));
 
-                tessellator.addVertexWithUV(xMax - e, (float)y + renderOffset, zMax - s,  cross.getSubIconU(1 - e), cross.getSubIconV(1 - s));
-                tessellator.addVertexWithUV(xMin + w, (float)y + renderOffset, zMax - s,  cross.getSubIconU(w),     cross.getSubIconV(1 - s));
-                tessellator.addVertexWithUV(xMin + w, (float)y + renderOffset, zMin + n,  cross.getSubIconU(w),     cross.getSubIconV(n));
-                tessellator.addVertexWithUV(xMax - e, (float)y + renderOffset, zMin + n,  cross.getSubIconU(1 - e), cross.getSubIconV(n));
+                tessellator.addVertexWithUV(xMax - e, (float) y + renderOffset, zMax - s, cross.getSubIconU(1 - e), cross.getSubIconV(1 - s));
+                tessellator.addVertexWithUV(xMin + w, (float) y + renderOffset, zMax - s, cross.getSubIconU(w), cross.getSubIconV(1 - s));
+                tessellator.addVertexWithUV(xMin + w, (float) y + renderOffset, zMin + n, cross.getSubIconU(w), cross.getSubIconV(n));
+                tessellator.addVertexWithUV(xMax - e, (float) y + renderOffset, zMin + n, cross.getSubIconU(1 - e), cross.getSubIconV(n));
 
 
             } else {
-                tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, cross.getIconUMax(), cross.getIconVMax());
-                tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, cross.getIconUMax(), cross.getIconVMin());
-                tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, cross.getIconUMin(), cross.getIconVMin());
-                tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, cross.getIconUMin(), cross.getIconVMax());
-
-                tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, cross.getIconUMax(), cross.getIconVMax());
-                tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, cross.getIconUMin(), cross.getIconVMax());
-                tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, cross.getIconUMin(), cross.getIconVMin());
-                tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, cross.getIconUMax(), cross.getIconVMin());
+                tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMax, cross.getIconUMax(), cross.getIconVMax());
+                tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMin, cross.getIconUMax(), cross.getIconVMin());
+                tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMin, cross.getIconUMin(), cross.getIconVMin());
+                tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMax, cross.getIconUMin(), cross.getIconVMax());
+
+                tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMax, cross.getIconUMax(), cross.getIconVMax());
+                tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMax, cross.getIconUMin(), cross.getIconVMax());
+                tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMin, cross.getIconUMin(), cross.getIconVMin());
+                tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMin, cross.getIconUMax(), cross.getIconVMin());
             }
 
         } else if (type == 1) { // East-West
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, straight.getIconUMin(), straight.getIconVMax());
-
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMin, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMax, straight.getIconUMin(), straight.getIconVMax());
+
+            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMax, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMin, straight.getIconUMax(), straight.getIconVMin());
         } else { // North-South
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMin());
-
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMin());
+
+            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float) y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, (float) y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMax());
         }
 
-        if (northUp){
-            tessellator.addVertexWithUV(xMin, (float)y + 1, z + renderOffset,   straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y,     z + renderOffset,   straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float)y,     z + renderOffset,   straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float)y + 1, z + renderOffset,   straight.getIconUMin(), straight.getIconVMax());
+        if (northUp) {
+            tessellator.addVertexWithUV(xMin, (float) y + 1, z + renderOffset, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float) y, z + renderOffset, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, (float) y, z + renderOffset, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, (float) y + 1, z + renderOffset, straight.getIconUMin(), straight.getIconVMax());
 
-            tessellator.addVertexWithUV(xMin, (float)y + 1, z + renderOffset,   straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float)y + 1, z + renderOffset,   straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float)y,     z + renderOffset,   straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y,     z + renderOffset,   straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float) y + 1, z + renderOffset, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, (float) y + 1, z + renderOffset, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, (float) y, z + renderOffset, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float) y, z + renderOffset, straight.getIconUMax(), straight.getIconVMin());
         }
-        if (southUp){
-            tessellator.addVertexWithUV(xMax, (float)y + 1, z + 1 - renderOffset,   straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float)y,     z + 1 - renderOffset,   straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y,     z + 1 - renderOffset,   straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y + 1, z + 1 - renderOffset,   straight.getIconUMin(), straight.getIconVMin());
-
-            tessellator.addVertexWithUV(xMax, (float)y + 1, z + 1 - renderOffset,   straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y + 1, z + 1 - renderOffset,   straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y,     z + 1 - renderOffset,   straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float)y,     z + 1 - renderOffset,   straight.getIconUMax(), straight.getIconVMax());
+        if (southUp) {
+            tessellator.addVertexWithUV(xMax, (float) y + 1, z + 1 - renderOffset, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, (float) y, z + 1 - renderOffset, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float) y, z + 1 - renderOffset, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float) y + 1, z + 1 - renderOffset, straight.getIconUMin(), straight.getIconVMin());
+
+            tessellator.addVertexWithUV(xMax, (float) y + 1, z + 1 - renderOffset, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float) y + 1, z + 1 - renderOffset, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float) y, z + 1 - renderOffset, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, (float) y, z + 1 - renderOffset, straight.getIconUMax(), straight.getIconVMax());
         }
-        if (eastUp){
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y + 1, zMin,   straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y,     zMin,   straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y,     zMax,   straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y + 1, zMax,   straight.getIconUMin(), straight.getIconVMin());
-
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y + 1, zMin,   straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y + 1, zMax,   straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y,     zMax,   straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y,     zMin,   straight.getIconUMax(), straight.getIconVMax());
+        if (eastUp) {
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y + 1, zMin, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y, zMin, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y, zMax, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y + 1, zMax, straight.getIconUMin(), straight.getIconVMin());
+
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y + 1, zMin, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y + 1, zMax, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y, zMax, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float) y, zMin, straight.getIconUMax(), straight.getIconVMax());
         }
-        if (westUp){
-            tessellator.addVertexWithUV(x + renderOffset, (float)y + 1, zMin,   straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(x + renderOffset, (float)y + 1, zMax,   straight.getIconUMin(), straight.getIconVMin());
-            tessellator.addVertexWithUV(x + renderOffset, (float)y,     zMax,   straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(x + renderOffset, (float)y,     zMin,   straight.getIconUMax(), straight.getIconVMax());
-
-            tessellator.addVertexWithUV(x + renderOffset, (float)y + 1, zMin,   straight.getIconUMin(), straight.getIconVMax());
-            tessellator.addVertexWithUV(x + renderOffset, (float)y,     zMin,   straight.getIconUMax(), straight.getIconVMax());
-            tessellator.addVertexWithUV(x + renderOffset, (float)y,     zMax,   straight.getIconUMax(), straight.getIconVMin());
-            tessellator.addVertexWithUV(x + renderOffset, (float)y + 1, zMax,   straight.getIconUMin(), straight.getIconVMin());
+        if (westUp) {
+            tessellator.addVertexWithUV(x + renderOffset, (float) y + 1, zMin, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + renderOffset, (float) y + 1, zMax, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + renderOffset, (float) y, zMax, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + renderOffset, (float) y, zMin, straight.getIconUMax(), straight.getIconVMax());
+
+            tessellator.addVertexWithUV(x + renderOffset, (float) y + 1, zMin, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + renderOffset, (float) y, zMin, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + renderOffset, (float) y, zMax, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + renderOffset, (float) y + 1, zMax, straight.getIconUMin(), straight.getIconVMin());
         }
 
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWool.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWool.java
index 8c00fc865..51517ce2f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWool.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWool.java
@@ -6,22 +6,24 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelWool<T extends BlockLogic> extends BlockModelStandard<T> {
     public static final IconCoordinate[] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT];
 
     static {
-        for (DyeColor c : DyeColor.blockOrderedColors()){
+        for (DyeColor c : DyeColor.blockOrderedColors()) {
             texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/wool/" + c.colorID);
         }
     }
+
     public BlockModelWool(Block<T> block) {
         super(block);
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         return texCoords[data & DyeColor.MASK_COLOR];
     }
 }
